// naumann@stce.rwth-aachen.de

#include <cmath>
#include <iostream>
using namespace std;

template<typename T>
T f(T x) {
  return pow(x,2);
}

template<typename T>
T df_dx(T x) {
  return 2*x;
}

template<typename T>
T ddf_dx_dx(T x) {
  return 2;
}

template<typename T>
T gradient_descent(T x) {
  do {
    cout << x << ": " << fabs(f(x)*ddf_dx_dx(x)/pow(df_dx(x),2)) << endl;
    x=x-df_dx(x);
  } while (fabs(df_dx(x))>1e-7);
  return x;
}

int main() {
  using T=double;
  T x=0.5;
  x=gradient_descent(x);
  cout << "x=" << x << endl;
  cout << "y=" << f(x) << endl;
  cout << "dfdx=" << df_dx(x) << endl;
  cout << "ddfdxx=" << ddf_dx_dx(x) << endl;
  return 0;
}
