// naumann@stce.rwth-aachen.de

#include <Eigen/Dense>
#include <iostream>
using namespace std;

template<typename T>
using VT=Eigen::VectorX<T>;

template<typename T>
VT<T> Householder(VT<T> x) {
  VT<T> v=x; v(0)=v(0)-x(0)/fabs(x(0))*x.norm();
  x=x-2*v*(v.dot(x)/v.dot(v));
  return x;
}

int main() {
  int m=5; 
  using T=double;
  VT<T> x=VT<T>::Random(m);
  cout << "x^T=" << x.transpose() << endl; 
  VT<T> y=Householder(x);
  cout << "(||x||*e_0)^T=" << endl << y.transpose() << endl << " = " 
       << endl << (x.norm()*VT<T>::Unit(m,0)).transpose() << endl;
  return 0;
}
