// naumann@stce.rwth-aachen.de

#include <Eigen/Dense>
#include <iostream>
using namespace std;

template<typename T>
using VT=Eigen::VectorX<T>;

template<typename T>
using MT=Eigen::MatrixX<T>;

template<typename T>
VT<T> Householder(VT<T> x) {
  int m=x.size();
  VT<T> v=x; v(0)=v(0)-x(0)/fabs(x(0))*x.norm();
  cout << "v^T=" << v.transpose() << endl;
  cout << "||v||=" << v.norm() << endl;
  MT<T> H=MT<T>::Identity(m,m)-2*v*v.transpose()/v.dot(v);
  cout << "H=" << endl << H << endl;
  return H*x;
}

int main() {
  int m=5; 
  using T=double;
  VT<T> x=VT<T>::Random(m);
  cout << "x^T=" << x.transpose() << endl;
  cout << "||x||=" << x.norm() << endl;
  x=Householder(x);
  cout << "x^T=(H*x)^T=" << x.transpose() << endl; 
  return 0;
}
