// naumann@stce.rwth-aachen.de

#include <Eigen/Dense>
#include <iostream>
using namespace std;

template<typename T>
using VT=Eigen::VectorX<T>;

template<typename T>
using MT=Eigen::MatrixX<T>;

template<typename T>
T Householder(VT<T> x, VT<T> y) {
  int m=x.size();
  VT<T> v=x; v(0)=v(0)-x(0)/fabs(x(0))*x.norm();
  cout << "v^T=" << v.transpose() << endl;
  cout << "||v||=" << v.norm() << endl;
  MT<T> H=MT<T>::Identity(m,m)-2*v*v.transpose()/v.dot(v);
  cout << "H=" << endl << H << endl;
  cout << "cond(H)=" << H.norm()*H.inverse().norm() << endl;
  x=H*x; 
  cout << "x^T=(H*x)^T=" << x.transpose() << endl; 
  y=H*y;
  cout << "y^T=(H*y)^T=" << y.transpose() << endl;
  return y(0)/x(0);
}

int main() {
  int m=5; 
  using T=double;
  VT<T> x=VT<T>::Random(m), y=VT<T>::Random(m); 
  x=x.cwiseProduct(x);
  cout << "x^T=" << x.transpose() << endl << "y^T=" << y.transpose() << endl;
  T p=Householder(x,y);
  cout << "p=" << p << endl;
  return 0;
}
