// naumann@stce.rwth-aachen.de

#include <Eigen/Dense>

#include <iostream>
#include <cmath>
using namespace std;

using VT=Eigen::VectorX<double>;

void plot(VT v, VT w) {
  std::cout << "set size square; plot [-1:1] [-1:1] " 
            << v(1) << '/' << v(0) << "*x, " << v(1) << ", "
            << w(1) << '/' << w(0) << "*x, " << w(1) << std::endl;
}

int main() {
  int n=2;
  VT v=VT::Random(n), w=VT::Random(n);
  plot(v,w);
  cout << 45*acos(v.dot(w)/(v.norm()*w.norm()))/atan(1.) << endl;
  return 0;
}
